//+------------------------------------------------------------------+
//|                                               EagleExpert_v1.mq4 |
//|                                  Copyright  2007, Forex-TSD.com |
//|                         Written by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |                                      
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#include <stdlib.mqh>

//---- input parameters
extern string     Expert_Name    = "EagleExpert_v1";

extern int        Magic          =   63333;
extern int        Slippage       =       3;

extern string     Main_data      = " Trade Volume & Trade Method";
extern double     Lots           =     0.1;
extern double     TakeProfit     =       0;    // Take Profit Value in pips 
extern int        StopLoss       =       0;    // Stop Loss value in pips 
extern int        TrailingStop   =       0;    // Trailing Stop value in pips 
extern double     BreakEven      =       0;    // Break-Even Value in pips
extern int        ExitMode       =       0;    // Exit Mode: 1-by CCI,2-by opposite Signal 
extern string     StartTime      = "00:00";    // Start Hour of Trade Session 
extern string     EndTime        = "23:00";    // End Hour of Trade Session
extern string     CloseTime      = "23:50";    // Trade Close Time   
extern int        CloseTimeMode  =       0;    // CloseTime mode: 0-off,1-on
extern bool       SignalMail     =   false;    // E-mail switch 

extern string     MA_Inputs      = " MAs parameters ";
extern int        MainTimeFrame  =       0;    // Main TimeFrame in min
extern int        MA_TimeFrame   =       0;    // MA's TimeFrame in min
extern int        FastLength     =       9;    // Length of fast MA 
extern int        SlowLength     =     100;    // Length of slow MA
extern int        MA_Mode        =       0;    // MA Mode 
extern int        MA_Price       =       0;    // Applied price 

extern string     CCI_Inputs     = " CCI parameters ";
extern int        CCI_TimeFrame  =       0;    // CCI's TimeFrame in min 
extern int        CCI_Length     =      14;    // CCI Length (Period)
extern double     CCI_BuyLevel   =       0;    // Buy Level  (positive value) 
extern double     CCI_SellLevel  =       0;    // Sell Level (negative value) 
extern int        CCI_Price      =       5;    // Applied Price 

extern string     RVI_Inputs     = " RVI parameters ";
extern int        RVI_TimeFrame  =       0;    // RVI's TimeFrame in min 
extern int        RVI_Length     =      14;    // RVI Length (Period)
extern double     RVI_BuyLevel   =       0;    // Buy Level  (positive value) 
extern double     RVI_SellLevel  =       0;    // Sell Level (negative value) 
extern int        RVI_Mode       =       0;    // RVI Mode: 0-main,1-signal  

extern string     MM_inputs      = " MoneyManagement by L.Williams ";
extern bool       MM             =   false;    //  Switch
extern double     MMRisk         =    0.15;    // Risk Factor
extern double     MaxLoss        =    1000;    // Maximum Loss by 1 Lot

int      OrderBar=0;
double   Lotsi;
int      BEvent=0, TriesNum=5;
datetime CurrBar,PrevBar;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
//---- 
   CurrBar = iTime(Symbol(),MainTimeFrame,0);
   PrevBar = iTime(Symbol(),MainTimeFrame,1);
//----
   return(0);
}

// ---- Scan Trades
int ScanTrades()
{   
   int total = OrdersTotal();
   int numords = 0;
      
   for(int cnt=0; cnt<total; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);            
   if(OrderSymbol() == Symbol() && OrderType()<=OP_SELLSTOP && OrderMagicNumber() == Magic) 
   numords++;
   }
   return(numords);
}  

bool TimeCondition()
{
   bool result = false;
   
   datetime SessionStart = StrToTime(StartTime);
   datetime SessionEnd   = StrToTime(EndTime);
   
   result = TimeCurrent() >= SessionStart && TimeCurrent() <= SessionEnd;      
   
   return(result);
}   
   
int TradeSignal()
{   
   double fMA1 = iMA(Symbol(),MA_TimeFrame,FastLength,0,MA_Mode,MA_Price,1);
   double fMA2 = iMA(Symbol(),MA_TimeFrame,FastLength,0,MA_Mode,MA_Price,2);
   
   double sMA1 = iMA(Symbol(),MA_TimeFrame,SlowLength,0,MA_Mode,MA_Price,1);
   double sMA2 = iMA(Symbol(),MA_TimeFrame,SlowLength,0,MA_Mode,MA_Price,2);
      
   double RVI = iRVI(Symbol(),RVI_TimeFrame,RVI_Length,RVI_Mode,1);
      
   if (fMA2 < sMA2 && fMA1 > sMA1 && RVI > RVI_BuyLevel ) return( 1);
   if (fMA2 > sMA2 && fMA1 < sMA1 && RVI < RVI_SellLevel) return(-1);
   
}

double MoneyManagement ( bool flag, double Lots, double risk, double maxloss)
{
   Lotsi=Lots;
	    
   if ( flag ) Lotsi=Lots*NormalizeDouble(Lots*AccountFreeMargin()*risk/maxloss,1);   
     
   if (Lotsi<0.1) Lotsi=0.1;  
      
   return(Lotsi);
}   


void TrailStop()
{
   int    error;  
   bool   result=false;
   double Gain = 0;
    
   for (int cnt=0;cnt<OrdersTotal();cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS);   
   int mode=OrderType();    
      if ( OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) 
      {
         if (mode==OP_BUY) 
         {
			   if ( BreakEven > TrailingStop && BEvent==0 )
			   {
			   Gain = (MarketInfo(Symbol(),MODE_BID) - OrderOpenPrice())/Point;
			      if( Gain >= BreakEven && OrderStopLoss()<=OrderOpenPrice()+1*Point) 
			      {
			      double BuyStop = NormalizeDouble(OrderOpenPrice()+1*Point,Digits);
			      BEvent=1;
			      }
			   }
			   else 			   
			   if( TrailingStop > 0) BuyStop = NormalizeDouble(MarketInfo(Symbol(),MODE_BID) - TrailingStop*Point,Digits);
			   
			   if( NormalizeDouble(OrderOpenPrice(),Digits)<= BuyStop) 
            {   
			      if ( BuyStop > NormalizeDouble(OrderStopLoss(),Digits) || OrderStopLoss() == 0) 
			      {
			         for(int k = 0 ; k < TriesNum; k++)
                  {
                  result = OrderModify(OrderTicket(),OrderOpenPrice(),
			                              BuyStop,
			                              OrderTakeProfit(),0,Lime);
                  error=GetLastError();
                     if(error==0) break;
                     else {Sleep(5000); RefreshRates(); continue;}
                  }   		 
               }            
            }
         }   
// - SELL Orders          
         if (mode==OP_SELL)
         {
            if ( BreakEven > TrailingStop && BEvent==0)
			   {
			   Gain = (OrderOpenPrice()-MarketInfo(Symbol(),MODE_ASK))/Point;
			   
			      if( Gain >= BreakEven && (OrderStopLoss()>=OrderOpenPrice()-1*Point || OrderStopLoss()== 0)) 
			      {
			      double SellStop = NormalizeDouble(OrderOpenPrice()-1*Point,Digits);
			      BEvent=-1;
			      }
			   }
			   else 
			   if( TrailingStop > 0) SellStop = NormalizeDouble(MarketInfo(Symbol(),MODE_ASK) + TrailingStop*Point,Digits);   
            
            if(NormalizeDouble(OrderOpenPrice(),Digits) >= SellStop && SellStop>0) 
            {
               if( SellStop < NormalizeDouble(OrderStopLoss(),Digits) || OrderStopLoss() == 0) 
               {
                  for( k = 0 ; k < TriesNum; k++)
                  {
                  result = OrderModify(OrderTicket(),OrderOpenPrice(),
			                              SellStop,
			                              OrderTakeProfit(),0,Orange);
                  error=GetLastError();
                     if(error==0) break;
                     else {Sleep(5000); RefreshRates(); continue;}
                  }
               }   
   			}	    
         }
      }
   }     
}


// ---- Open Sell Orders
void SellOrdOpen()
{		     
   double SellPrice = Bid;
   double StopPrice = Bid;
   int    Mode = OP_SELL;
        	  
   if (StopLoss > 0) 
   double SellStop  = SellPrice + StopLoss*Point;
   else SellStop = 0;
	
   if (TakeProfit  > 0) double SellProfit = SellPrice - TakeProfit*Point; 
   else SellProfit=0;
   
	int ticket = OrderSend( Symbol(),Mode,MoneyManagement ( MM, Lots, MMRisk, MaxLoss),
	                        NormalizeDouble(SellPrice , Digits),
	                        Slippage,
	                        NormalizeDouble(SellStop  , Digits),
	                        NormalizeDouble(SellProfit, Digits),
	                        Expert_Name+" SELL",Magic,0,Red);
   
   if(ticket > 0) 
   {
      if (OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) 
      {
		//OrderBar =iBars(OrderSymbol(),BT_TimeFrame);
		Print("SELL order opened : ", OrderOpenPrice());
      BEvent=0;
      if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Open Sell");
		}
   }
	else 	
   if(GetLastError()>0)
   Print("SELL: OrderSend failed with error #",GetLastError());
   
   return(0);
}
// ---- Open Buy Orders
void BuyOrdOpen()
{		     
   double BuyPrice  = Ask;
   double StopPrice = Ask;
   int    Mode      = OP_BUY;
      
   if (StopLoss > 0) 
   double BuyStop  = BuyPrice - StopLoss*Point;
   else BuyStop = 0;
   
   if (TakeProfit  > 0) double BuyProfit= BuyPrice + TakeProfit*Point;  
   else BuyProfit=0;  
		 
	int ticket = OrderSend(Symbol(),Mode, MoneyManagement ( MM, Lots, MMRisk, MaxLoss),
	                   NormalizeDouble(BuyPrice , Digits),
	                   Slippage,
	                   NormalizeDouble(BuyStop  , Digits), 
	                   NormalizeDouble(BuyProfit, Digits),
	                   Expert_Name+" BUY",Magic,0,Blue);
      
   if(ticket > 0) 
   {
      if (OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) 
      {
		//OrderBar =iBars(OrderSymbol(),BT_TimeFrame); 
		Print("BUY order opened : ", OrderOpenPrice());
      BEvent=0;
      if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Open Buy");
		}
   }
	else 	
   if(GetLastError()>0)      
   Print("BUY : OrderSend failed with error #",GetLastError());

   return(0);
} 

void CloseOrder(int mode)  
{
   bool result=false; 
   int  total=OrdersTotal();
   
   for (int i=0; i<=OrdersTotal(); i++)  
   {
   OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if (OrderMagicNumber() == Magic && OrderSymbol() == Symbol()) 
      {
      if ((mode == 0 || mode ==1) && OrderType()==OP_BUY ) result=CloseAtMarket(OrderTicket(),OrderLots(),Aqua);
      if ((mode == 0 || mode ==2) && OrderType()==OP_SELL) result=CloseAtMarket(OrderTicket(),OrderLots(),Pink);
      }
   }
}


bool CloseAtMarket(int ticket,double lot,color clr) 
{
   bool result = false; 
   int  ntr;
      
   int tries=0;
   while (!result && tries < TriesNum) 
   {
      //ntr=0; 
      //while (ntr<5 && !IsTradeAllowed()) { ntr++; Sleep(5000); }
      RefreshRates();
      result=OrderClose(ticket,lot,OrderClosePrice(),Slippage,clr);
      tries++;
   }
   if (!result) Print("Error closing order : ",ErrorDescription(GetLastError()));
   return(result);
}

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   if(iBars(Symbol(),MA_TimeFrame) < SlowLength || IsTradeAllowed()==false) return(0); 
      
   if(AccountFreeMargin()< 1000*MoneyManagement ( MM, Lots, MMRisk, MaxLoss))
   {
   Print("We have no money. Free Margin = ", AccountFreeMargin());
   return(0);  
   }
   CurrBar = iTime(Symbol(),MainTimeFrame,0);
   
   datetime TimeClose = StrToTime(CloseTime); 
   
   if (CurrBar != PrevBar)
   {
      int Signal = TradeSignal();
      double CCI = iCCI(Symbol(),CCI_TimeFrame,CCI_Length,CCI_Price,1); 
      
      if(ScanTrades()>0)
      {
         if(ExitMode == 1)
         {
         if ( CCI > CCI_BuyLevel ) CloseOrder(2);
         if ( CCI < CCI_SellLevel) CloseOrder(1);
         }
         
         if(ExitMode == 2)
         {
         if (Signal > 0) CloseOrder(2);
         if (Signal < 0) CloseOrder(1);
         }
      
      if (CloseTimeMode > 0 && TimeCurrent() >= TimeClose) CloseOrder(0); 
      }
      
      if(ScanTrades()==0)
      {
      if (Signal > 0 && TimeCondition()) BuyOrdOpen() ;
      if (Signal < 0 && TimeCondition()) SellOrdOpen();
      }
   }
   else
   if(ScanTrades()>0)
   {
   if(BreakEven>0 || TrailingStop>0) TrailStop();
   }
   PrevBar = CurrBar;
   
//----
   return(0);
} //start()
//+------------------------------------------------------------------+